/* 
 * HORDGET
 * (c)2010 par Stravingo
 * http://stravingo.over-blog.fr
 *
 * Hordget est un widget pour MacOS X (10.4.3 minimum) permettant d'afficher dans le Dashboard
 * des informations relatives au jeu Hordes de Motion Twin (wwww.hordes.fr)
 */
 
 
 //
 // Variables globales
 //
 var pseudo = "";   // Pseudo du joueur
 var clef = "";     // Clef externe du joueur
 

//
// Function: charge_xml()
// Charge le fichier XML de Hordes correspondant au compte défini par la clef externe
// et affiche les informations qu'il contient.
//
 function charge_xml()
 {
            document.getElementById("NomVille").innerHTML = "";
            document.getElementById("NumJour").innerHTML = "";
            document.getElementById("Defense").innerHTML = "";
            document.getElementById("Eau").innerHTML = "";
            document.getElementById("Heure").innerHTML = "";
            document.getElementById("NbCitoyens").innerHTML = "";
            document.getElementById("NbBasic").innerHTML = "";
            document.getElementById("NbCollec").innerHTML = "";
            document.getElementById("NbEclair").innerHTML = "";
            document.getElementById("NbGuardian").innerHTML = "";
            document.getElementById("NbHunter").innerHTML = "";
            document.getElementById("NbTamer").innerHTML = "";
            document.getElementById("EstimationMin").innerHTML = "";
            document.getElementById("AttaqueHier").innerHTML = "";
    
    if (window.XMLHttpRequest)
    {
        xmlhttp=new XMLHttpRequest();
    }

    if( clef != "" )
    {
        var url;
        
        // Vérifie si le site est ouvert
        url = "http://www.hordes.fr/xml/status";
        xmlhttp.open("GET",url,false);
        xmlhttp.send();
        xmlDoc=xmlhttp.responseXML;
        var status_site = xmlDoc.getElementsByTagName("status")[0].getAttribute("open");
        if( status_site != "1" )
        {
            document.getElementById("frontImg").src = "Images/-fond_vide_v3.png";
            document.getElementById("MessageErreur").innerHTML = "Hordes est fermé !<p>" + xmlDoc.getElementsByTagName("status")[0].getAttribute("msg");
            return;
        }
        
        
        
        url = "http://www.hordes.fr/xml?k=" + clef;
        xmlhttp.open("GET",url,false);
        xmlhttp.send();
        xmlDoc=xmlhttp.responseXML;
        
        
        // Vérifie les éventuelles erreurs
        var error = xmlDoc.getElementsByTagName("error");
        if( error.length > 0 )
        {
            var error_code = xmlDoc.getElementsByTagName("error")[0].getAttribute("code");
            
            document.getElementById("frontImg").src = "Images/-fond_vide_v3.png";

            
            // ERREUR : clef externe incorrecte
            if( error_code == "user_not_found" )
            {
                
                document.getElementById("MessageErreur").innerHTML = "<b>Utilisateur non reconnu !</b><p>Cliquez sur le coin du widget en bas à droite pour régler votre pseudo et votre clef externe (voir www.hordes.fr)";
            }
            // ERREUR : la horde attaque
            else if( error_code == "horde_attacking" )
            {
                document.getElementById("MessageErreur").innerHTML = 'La horde attaque ! <img src="http://www.hordes.fr/gfx/forum/smiley/h_horror.gif" />';
            }
            // ERREUR : le joueur n'est pas en jeu
            else if( error_code == "not_in_game" )
            {
                document.getElementById("MessageErreur").innerHTML = 'Vous êtes mort. Juste ciel <img src="http://www.hordes.fr/gfx/forum/smiley/h_horror.gif" />';
            }
            // Autres erreurs
            else
            {
                document.getElementById("MessageErreur").innerHTML = "ERREUR";
            }
            
            return;
        }
        
        document.getElementById("MessageErreur").innerHTML = "";
        
        // Affiche l'image de fond correspondant à la porte ouverte ou fermée
        if( xmlDoc.getElementsByTagName("city")[0].getAttribute("door") == "1" )
        {
            document.getElementById("frontImg").src = "Images/-fond_ouvert_v3.png";
        }
        else
        {
            document.getElementById("frontImg").src = "Images/-fond_ferme_v3.png";
        }
    
        // Nom de la ville
        var nom_ville = xmlDoc.getElementsByTagName("city")[0].getAttribute("city");
        document.getElementById("NomVille").innerHTML = nom_ville.toUpperCase();
        
        // Nombre de jours
        var num_jour = xmlDoc.getElementsByTagName("game")[0].getAttribute("days");
        document.getElementById("NumJour").innerHTML = num_jour;
        
        // Défense (si non Pandémonium)
        if( xmlDoc.getElementsByTagName("city")[0].getAttribute("hard") == "0" )
        {
            var defense = xmlDoc.getElementsByTagName("defense")[0].getAttribute("total");
            document.getElementById("Defense").innerHTML = "Défense: "+defense;
        }
        else
        {
            document.getElementById("Defense").innerHTML = "Pandémonium";
        }
        
        // Eau
        var eau = xmlDoc.getElementsByTagName("city")[0].getAttribute("water");
        document.getElementById("Eau").innerHTML = "Eau: "+eau;
        
        // Heure
        var heure = xmlDoc.getElementsByTagName("game")[0].getAttribute("datetime");
        var t = heure.split(/[- :]/);
        var h = t[3] + ":" + t[4];
        document.getElementById("Heure").innerHTML = h;
        
        // Attaque de la nuit précédente
        var news = xmlDoc.getElementsByTagName("news");
        if( news.length > 0 )
        {
            var attaque_hier = xmlDoc.getElementsByTagName("news")[0].getAttribute("z");
            document.getElementById("AttaqueHier").innerHTML = attaque_hier;
        }
        
        // Estimations min et max
        var estimations = xmlDoc.getElementsByTagName("e");
        if( estimations.length > 0 )
        {
            var estimation_min = xmlDoc.getElementsByTagName("e")[0].getAttribute("min");
            var estimation_max = xmlDoc.getElementsByTagName("e")[0].getAttribute("max");
            document.getElementById("EstimationMin").innerHTML = estimation_min + "-" + estimation_max;
        }
       
        // Nombre de citoyens vivants et de morts
        citoyens=xmlDoc.getElementsByTagName("citizen");
        cadavres=xmlDoc.getElementsByTagName("cadaver");
        
        document.getElementById("NbCitoyens").innerHTML = citoyens.length + " citoyens <i>(+" + cadavres.length + " morts)</i>";
        
        // Nombre de citoyens de chaque classe
        var nb_basic = 0;
        var nb_collec = 0;
        var nb_eclair = 0;
        var nb_guardian = 0;
        var nb_hunter = 0;
        var nb_tamer = 0;

        for(i=0;i<citoyens.length;i++)
        {
            if( citoyens[i].getAttribute("job") == "basic" )
            {
                nb_basic++;
            }
            if( citoyens[i].getAttribute("job") == "collec" )
            {
                nb_collec++;
            }
            if( citoyens[i].getAttribute("job") == "eclair" )
            {
                nb_eclair++;
            }
            if( citoyens[i].getAttribute("job") == "guardian" )
            {
                nb_guardian++;
            }
            if( citoyens[i].getAttribute("job") == "hunter" )
            {
                nb_hunter++;
            }
            if( citoyens[i].getAttribute("job") == "tamer" )
            {
                nb_tamer++;
            }
        }
        
        document.getElementById("NbBasic").innerHTML = nb_basic;
        document.getElementById("NbCollec").innerHTML = nb_collec;
        document.getElementById("NbEclair").innerHTML = nb_eclair;
        document.getElementById("NbGuardian").innerHTML = nb_guardian;
        document.getElementById("NbHunter").innerHTML = nb_hunter;
        document.getElementById("NbTamer").innerHTML = nb_tamer;
    }
 }
 

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    dashcode.setupParts();
    
    if (window.widget) {
        pseudo = widget.PreferenceForKey("pseudo");
        clef = widget.PreferenceForKey("clef");
    }
    
    
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
    charge_xml();
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
        document.getElementById("textFieldPseudo").value = pseudo;
        document.getElementById("textFieldClef").value = clef;
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
        pseudo = document.getElementById("textFieldPseudo").value;
        clef = document.getElementById("textFieldClef").value;
        widget.setPreferenceForKey(pseudo,"pseudo");
        widget.setPreferenceForKey(clef,"clef");
        charge_xml();
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}

//
// Function: lance_blog(event)
// Lance le blog de Stravingo dans un navigateur web
//
function lance_blog(event)
{
    if (window.widget) { 
        widget.openURL("http://stravingo.over-blog.fr"); 
     } 
}

//
// Function: lance_hordes(event)
// Lance le site de Hordes dans un navigateur web
//
function lance_hordes(event)
{
    if (window.widget) { 
        widget.openURL("http://www.hordes.fr?ref=stravingo"); 
     } 
}
